/* cgi.c 
 *  By Charles Shiflett
 *    Originally written 6/99
 *    "Fixed" 3/03 - See note below 
 *    
 *    Functional interface in cgi.h
 *
 *  This code is messy, and needs to be rewritten. decode_input() is especially
 *  bad. The interface is however clean.
 *
 * BUGS:
 *
 *  Calling cgi.c with QUERY_STRING="foo=blah&...&this="
 *    causes crashing.... Work around. terminate with & or make sure data
 *                                     exists for all end assignments
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/uio.h>
#include <unistd.h>
#include <string.h>
#include <fcntl.h>
#include "cgi.h"
/* NOTE: RBS is broken! Decode input does not work as it should.
 */


/* char* add_hash ( key, data ) 
 *	Adds the data to a structure accessible by key... 
 *		returns 0 on failure
 * note: This structure is currently very primitive
 *****/
static form_str **form=0;
int add_hash ( char* key, char* data ) {
	static int current_element=0;

	#ifdef DEBUG_KEYS
	printf("adding '%s'='%s'\n", key, data);
	#endif

	if (getenv("RESTART"))  {
		form=0; current_element=0;
		unsetenv("RESTART");
	}

	if ( !form )
		form=malloc(MAX_VARS*sizeof(void*)+7);
	if ( current_element > MAX_VARS)
		return 0;

	if ( !key || !data )
		return 0;

	form[current_element] = (form_str*) malloc( sizeof(char*) * 2 );
	form[current_element]->name=malloc(strlen(key)+8);
	form[current_element]->data=malloc(strlen(data)+8);
	bcopy( key, form[current_element]->name, strlen(key));
	bcopy( data, form[current_element]->data, strlen(data));
	form[current_element]->name[strlen(key)]=0;
	form[current_element]->data[strlen(data)]=0;

	current_element++;
	form[current_element]=0;

	return 1;

}

/* data get_data( key ) 
 * returns a pointer to the data associated with key 
 *****/
char* get_data ( char* key ) {
	static int run_yet=0;
	int counter=0;

	#ifdef DEBUG_KEYS2
	 printf("Requested %s",key);
	#endif

	if (getenv("RESTART")) 
		run_yet=0;

	if (!run_yet) {
		init_cgi();
		run_yet=1;
	}
	if (!form) 
		return 0;

	while ( (form[counter] != 0) && (strcmp(key, form[counter]->name)) )
		counter++;
	if (form[counter] ) {
		#ifdef DEBUG_KEYS2
		 printf(",returned %s\n",form[counter]->data);
		#endif
		return(form[counter]->data); 
	}
	#ifdef DEBUG_KEYS2
		printf(",returned NULL\n");
	#endif
	return(0);

}

/* char* url_decode (string)
 * url_decode destructively converts a url ecoded string into a non url
 * url encoded string. returns pointer to url decoded string 
 *
 * Note: Return string is currently the same string, this could change
 ****/

char* url_decode (char* foo) {
	char *front, *back; 
	int hex;
	front = back = foo;

	while ( *front ) {
		if ( *front == '+') 
			*back = ' ';
		else {
			if ( *front == '%' ) {
					/* convert hex string to hex number */
					front++;
					if (*front > 0x40) {
						/* Check case of A-F hex value */
						if (*front < 0x50)
							hex=(*front-0x37) << 4;
						else 
							hex=(*front-0x57) << 4;
					}
					else
						hex=(*front-0x30) << 4;
					front++;
					if (*front > 0x40) {
						/* Check case of A-F hex value */
						if (*front < 0x50)
							hex=hex | (*front-0x37);
						else
							hex=hex | (*front-0x57);
					}
					else
						hex=hex | (*front-0x30);
					*back=hex;
			} else
				*back=*front;
		}

		front++;
		back++;
	}
	*back=0;
	return(foo);
		
}

/* char* decode_input ( ) 
 *  Must be called once per data element 
 *	Decodes input using get_input and puts into add_hash for later retrieval
 *****/
int decode_input( ) {
	int chars_read=5;
	static char *in_buf, *name, *data, *temp; 
	static char *foo=0, *inited=0;

	if (getenv("RESTART")) 
		inited=0;

	if (!inited) {
		in_buf=malloc(RBS+1);
		chars_read=read_input(in_buf, RBS);
		temp=in_buf;
		inited++;
	}

	if (chars_read < 1)
		return(NO_DATA);

	/* Form data comes in the form foo=blah&bar=foo... we need to parse that */
	/* Note: The following parses name, this should be its own procedure w/ da*/
	name=strsep(&temp, "=");

	if ( !temp ) 
		/* this is a sanity check, if temp == null bad things are happening */
		return NO_DATA;

	if (!*temp) {
		/* Yipes, name not followed by data... we need to fix that */
		if ( foo ) 
			/* old useless memory, clean it up */
			free(foo);

		/* Back up data in name so that we can read in more data */
		foo = malloc(strlen(name)+RBS);
		bcopy(name, foo, strlen(name));
		chars_read=read_input(in_buf, RBS);

		if (chars_read < 1) 
			/* No more data left... there is nothing more to do */
			return(NO_DATA);
		/* Can't change in_buf so use temp instead */
		temp=in_buf;
		name=strsep(&temp, "=");
		if (!*temp) 
			/* No name should ever be this long */
			return(BAD_DATA);
		strcat(foo, temp);
		name=foo;
	}
	
	/* Note: The following parses data, this should be its own procedure w/ na*/
	data=strsep(&temp, "&");
	#ifdef ON_CRACK
	while (temp && !*temp) {
		/* If no data, keep reading data until all data read */
		if ( foo ) 
			/* old useless memory, clean it up */
			free(foo);
		foo = malloc(strlen(data)+RBS);
		bcopy(data, foo, strlen(data));
		chars_read=read_input(in_buf, RBS);
		/* I don't think this is needed
		if (chars_read < 1)
			return(NO_DATA);
		*/
		/* Can't change in_buf so use temp instead */
		temp=in_buf;
		name=strsep(&temp, "&");
		strcat(foo, temp);
		data=temp;
	}
	#endif

	add_hash(name, url_decode(data));
	return(23);

}

int read_post(char* buf, int size){
 	int foo;
 	static int fcntled=0;
 	if (!fcntled)
 		fcntl(STDIN_FILENO, F_SETFL, O_NONBLOCK);

	foo=read(STDIN_FILENO, buf, size);

	/* ensure that data is terminated by a NULL */
	buf[strlen(buf)] = 0;
	return(foo);
}

int read_get(char* buf, int size){
	static char* query_string=0;
	if (!query_string || getenv("RESTART"))
		query_string=getenv("QUERY_STRING");
	strncpy(buf, query_string, size);
	query_string+=strlen(buf);
	return(strlen(buf)); 
}

/* int read_input (buf, size) 
 *		A generic read function... Determines wethor we are doing post or
 *		get based on the existance of the QUERY_STRING variable
 *****/
int read_input(char* buf, int size){
	char *foobar;
	foobar=getenv("QUERY_STRING");
	if (foobar && *foobar) 
		return(read_get(buf, size));
	return(read_post(buf,size));
}

/* void init_cgi()
 * 	Initializes the cgi library... parses input data...
 ******/
void init_cgi() {
	static already_done=0;
	int count=0;

	if (getenv("RESTART")) 
		already_done=0;

	if (!already_done) {
		already_done++;
		if (!getenv("NO_HEADERS")) {
			printf("Server: cgi.c By Bear\n");
			printf("Content-Type: text/html\n\n");
		}
		for (count=0; count < MAX_VARS; count++ )
			if(!decode_input())
				return;
	}


}


#ifdef THIS_PROGRAM_IS_BROKEN
int main () {
	char *rhost;
	rhost = getenv("REMOTE_HOST");
	init_cgi();
	printf("<HTML><BODY>in_buf -> %s<BR>%s<BR>%s<BR>\n\n",get_data("data") , get_data("syntax"), rhost);
	return(0);
}
#endif
